unit Unit_form1;
// Repertoire := ExtractFilePath(Application.ExeName);

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CoolTrayIcon, TextTrayIcon, ActnList, StdActns, Menus, ImgList,
  StdCtrls, ShellApi, ComCtrls, jpeg, ExtCtrls, BandActn, JvExControls,
  JvGradientHeaderPanel,
  unit_Doc2RTF, JvComponentBase, JvDragDrop,
  jc_INI, jc_reg;

type
  TForm1 = class(TForm)
    TextTrayIcon1: TTextTrayIcon;
    Popup_Tray: TPopupMenu;
    ActionList1: TActionList;
    Quitter1: TMenuItem;
    ImageList1: TImageList;
    Maximiser: TAction;
    Maximiser1: TMenuItem;
    N1: TMenuItem;
    Minimiser: TAction;
    Minimiser1: TMenuItem;
    StatusBar1: TStatusBar;
    SAISIE_DOS: TAction;
    MEMO_CONF: TMemo;
    Sauve_POS_Saisie: TAction;
    Sauve_POS_Form1: TAction;
    SAUVE_POSITIONS: TAction;
    Enregistrelapositiondesfentres1: TMenuItem;
    OPTIONS: TAction;
    affDocument: TMenuItem;
    Affiche_RTF: TAction;
    Explore_DATA: TAction;
    Memo: TAction;
    TypeOf_DOCS: TAction;
    ypesdedocumentsaccepts1: TMenuItem;
    Coller1: TMenuItem;
    N6: TMenuItem;
    Coller: TAction;
    Affiche_MEMO: TAction;
    run_PP: TAction;
    run_FIND: TAction;
    Changer_titre: TAction;
    Ouvrir_WRITE: TAction;
    JvGradientHeaderPanel1: TJvGradientHeaderPanel;
    Reinit: TAction;
    N2: TMenuItem;
    N4: TMenuItem;
    RAZ1: TMenuItem;
    OuvrirleWordPADdeWindows1: TMenuItem;
    Changerletitredelafentre1: TMenuItem;
    OuvrirlePressepapier1: TMenuItem;
    OuvrirMmo1: TMenuItem;
    ExplorerdedossierDATA1: TMenuItem;
    PROGRAM_VISUDOC: TAction;
    PROGRAMVISUDOC1: TMenuItem;
    N5: TMenuItem;
    OPEN: TMenuItem;
    JvDragDrop1: TJvDragDrop;
    Quitter2: TMenuItem;
    N3: TMenuItem;
    FileExit1: TFileExit;
    Quitter: TAction;
    Popup_Form: TPopupMenu;
    Quitter3: TMenuItem;
    Coller2: TMenuItem;
    N7: TMenuItem;
    Mode_AUTORUN: TMenuItem;
    INI_GET: TAction;
    INI_SAVE: TAction;
    Restaurerlesparamtresdeconfiguration1: TMenuItem;
    CHK_explore: TMenuItem;
    Options1: TMenuItem;
    N8: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure MaximiserExecute(Sender: TObject);
    procedure MinimiserExecute(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure SAISIE_DOSExecute(Sender: TObject);
    procedure affDocumentClick(Sender: TObject);
    procedure Explore_DATAExecute(Sender: TObject);
    procedure MemoExecute(Sender: TObject);
    procedure TypeOf_DOCSExecute(Sender: TObject);
    procedure CollerExecute(Sender: TObject);
    procedure Affiche_RTFExecute(Sender: TObject);
    procedure Affiche_MEMOExecute(Sender: TObject);
    procedure run_FCClick(Sender: TObject);
    procedure run_PPExecute(Sender: TObject);
    procedure run_FINDExecute(Sender: TObject);
    procedure Changer_titreExecute(Sender: TObject);
    procedure QuitterExecute(Sender: TObject);
    procedure JvGradientHeaderPanel1DblClick(Sender: TObject);
    procedure Ouvrir_WRITEExecute(Sender: TObject);
    procedure ReinitExecute(Sender: TObject);
    procedure PROGRAM_VISUDOCExecute(Sender: TObject);
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
      Value: TStrings);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FileExit1Hint(var HintStr: String; var CanShow: Boolean);
    procedure Mode_AUTORUNClick(Sender: TObject);
    procedure INI_GETExecute(Sender: TObject);
    procedure INI_SAVEExecute(Sender: TObject);
    procedure CHK_exploreClick(Sender: TObject);
    procedure OPTIONSExecute(Sender: TObject);

	  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

type TBUF = record
   NOM		: String;
   PRENOM	: String;
   PREFIXE: string;
end;

var
  Form1: TForm1;
  Dropped_FileName : array [0..255] of char;
  FN, EXT : string;

  _BUF : TBUF; // buffer gnral

  Mode : integer; // mode de fonctionnement 0 = DRAG 1 = CLIP
  App_PATH, INI_FILE, DOS_ROOT, DOS_DATA, DOS_CONF, DOS_HELP : string;
  NOM_PRENOM_DDN, FICHIER_PATIENT, DOSSIER_PATIENT : string;
  INDEX_INI : string;

CONST
	_MODE_DRAG =0;
  _MODE_CLIP =1;

implementation

uses visu_doc, form_OPTIONS;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin

INI_GET.Execute;

// Active le Drag and drop entre Windows et Moi
form1.JvDragDrop1.AcceptDrag := true;

// Arrondit les angles
SetWindowRgn(
	form1.handle,
	CreateRoundRectRgn(6,6,form1.width,form1.height,6,6),
	true);

form1.JvGradientHeaderPanel1.LabelTop := 30;



end;

procedure TForm1.MaximiserExecute(Sender: TObject);
begin

form1.TextTrayIcon1.ShowMainForm;
form1.TextTrayIcon1.Text := '+';


end;

procedure TForm1.MinimiserExecute(Sender: TObject);
begin

form1.TextTrayIcon1.HideMainForm;
form1.TextTrayIcon1.Text := '...';

end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
Application.Terminate;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TForm1.SAISIE_DOSExecute(Sender: TObject);
////////////////////////////////////////////////////////////////////////////////


begin

with frm_visudoc do begin
  jvCaptionDOC.caption := Dropped_Filename;
  EXT :=  UpperCase(ExtractFileExt(Dropped_Filename));

  // WebBrowser1.Align := AlClient;
  PdfViewer1.Align := AlClient;
  Image1.align := AlClient;
  JvAnimate1.align := AlClient;
  jvanimate1.active := False;
  JvAnimate1.transparent:= true;

if (EXT = '.TXT') or (EXT = '.INI')or (EXT = '.HPM') or (EXT = '.HPR')then begin
	form1.Affiche_RTF.Execute;
  jvRichEdit1.PlainText := True;
	jvRichEdit1.Lines.LoadFromFile( Dropped_Filename );

//	Memo1.Lines.LoadFromFile( Dropped_Filename );
  end

else if EXT = '.RTF' then begin
	Affiche_RTF.execute;
  jvRichEdit1.PlainText := False;
	jvRichEdit1.Lines.LoadFromFile( Dropped_Filename );
  end

else if EXT = '.DOC' then begin

	Affiche_RTF.execute;
  jvRichEdit1.PlainText := False ;

  // Conversion DOC + RTF
	jvRichEdit1.text := Doc2RTF( Dropped_Filename );
 	jvRichEdit1.text := '';

  jvRichEdit1.Lines.LoadFromFile( Dropped_Filename );
                
  end

  else if (EXT = '.HTML') or (EXT = '.HTM') then begin
//  WebBrowser1.Navigate(Dropped_FileName,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
  end

else if EXT = '.PDF' then begin
//	memo1.Visible := False;     
	Panel_RTF.Visible := false;
//  WebBrowser1.Visible := false;
  PdfViewer1.Visible := True;
	Image1.Visible := false;
  JvAnimate1.Visible := False;

  frm_visudoc.PdfViewer1.filename := Dropped_FileName;
  end

else if (EXT = '.JPG') or (EXT = '.JPEG') or (EXT = '.BMP') then begin
//	memo1.Visible := False;     
	Panel_RTF.Visible := false;
//  WebBrowser1.Visible := false;
  PdfViewer1.Visible := false;
	Image1.Visible := True;
  JvAnimate1.Visible := False;

  frm_visudoc.image1.Picture.LoadFromFile  (Dropped_FileName);
  end
else if EXT = '.AVI' then begin
//	memo1.Visible := False;
	Panel_RTF.Visible := false;
//  WebBrowser1.Visible := false;
  PdfViewer1.Visible := false;
	Image1.Visible := False;
  JvAnimate1.Visible := True;

  // Image1.BringToFront;
  frm_visudoc.JvAnimate1.FileName := Dropped_FileName;
  jvanimate1.active := True;
  end
  

else begin
	showmessage('Format ' + ext + ' Inconnu' + #13+#13+
  '=> Dposez du TXT,INI,RTF,PDF,JPG,JPEG,BMP,AVI');
	Exit;
  
  end
End;
   
frm_visudoc.show;

end;



procedure TForm1.affDocumentClick(Sender: TObject);
begin

affDocument.Checked := Not AffDocument.checked;
frm_VisuDoc.Visible := affDocument.checked;

end;

procedure TForm1.Explore_DATAExecute(Sender: TObject);
begin

shellExecute (0,'EXPLORE', PansiChar(DOS_DATA), nil,nil, sw_show);


end;

procedure TForm1.MemoExecute(Sender: TObject);
begin

ShellExecute(0,'OPEN','NOTEPAD.EXE', '_MEMO.TXT',  pchar(app_path), sw_show);


end;

procedure TForm1.TypeOf_DOCSExecute(Sender: TObject);
begin


application.MessageBox(
'TEXTES:'+#13+
'-TXT,RTF,PDF'+#13+
#13+
'IMAGES:' + #13 +
'-BMP,JPG,JPEG'+#13+
#13+
'VIDEOS:'+#13+
'-AVI',
'TYPES DE DOBUMENTS ACCEPTES', mb_IconInformation );




end;


procedure TForm1.CollerExecute(Sender: TObject);
begin

// COLLE LE RESULTAT DU PRESSE PAPIER

MODE := _MODE_CLIP; // Mode clipBoard

FICHIER_PATIENT := FormatDateTime ('yyyy-mm-dd_hh-nn-ss',now) + '.RTF';

frm_visudoc.Caption := FICHIER_PATIENT;
frm_visudoc.jvRichEdit1.Text := ''; // Vide le RTF

frm_visudoc.jvRichEdit1.PasteFromClipboard; // Colle le PP

if trim(frm_visudoc.jvRichEdit1.text ) <> '' then begin
	frm_visudoc.Show;
	Affiche_RTF.Execute;
  end
else
	  form1.TextTrayIcon1.ShowBalloonHint(
    'Le Presse Papier est vide !',
    'Utilisez CTRL+C pour placer du texte dans le presse papier',
   	bitInfo, 10);

    end;

procedure TForm1.Affiche_RTFExecute(Sender: TObject);
begin

with frm_VisuDoc do begin

//	memo1.Visible := False;
//  WebBrowser1.Visible := false;
  PdfViewer1.Visible := false;
	Image1.Visible := false;
  JvAnimate1.Visible := False;

	Panel_RTF.Visible := True;
  Panel_RTF.Align := AlClient
  
end;

end;

procedure TForm1.Affiche_MEMOExecute(Sender: TObject);
begin

with frm_visudoc do begin

//	memo1.Visible := True;     
	Panel_RTF.Visible := false;
// WebBrowser1.Visible := false;
  PdfViewer1.Visible := false;
	Image1.Visible := false;
  JvAnimate1.Visible := False;
end;

end;

procedure TForm1.run_FCClick(Sender: TObject);
begin

ShellExecute (0,'OPEN', 
	'C:\Program Files\FreeCommander\FreeCommander.exe',
  PAnsiChar(DOS_DATA), nil,sw_show);


end;

procedure TForm1.run_PPExecute(Sender: TObject);
begin

shellExecute(0,'OPEN','CLIPBRD.EXE', nil,nil,sw_show);

end;

procedure TForm1.run_FINDExecute(Sender: TObject);
begin

ShellExecute(0,'FIND',PAnsiChar(DOS_DATA), nil,nil,sw_show);


end;

procedure TForm1.Changer_titreExecute(Sender: TObject);
var titre : string;

begin

if inputQuery('Entrez un titre','TITRE', titre) then
	form1.caption := Titre;

end;

procedure TForm1.QuitterExecute(Sender: TObject);
begin

// ini_Save.execute;
Application.terminate;

end;

procedure TForm1.JvGradientHeaderPanel1DblClick(Sender: TObject);
begin

showmessage('OK');

end;

procedure TForm1.Ouvrir_WRITEExecute(Sender: TObject);
begin

ShellExecute(0,'OPEN','WRITE.EXE',nil,nil,sw_show);

end;

procedure TForm1.ReinitExecute(Sender: TObject);
begin

deletefile(INI_FILE);
application.Terminate;

end;

procedure TForm1.PROGRAM_VISUDOCExecute(Sender: TObject);
var FN : string  ;
begin

FN := App_Path + '\visu_doc.exe';
ShellExecute( handle, 'OPEN', PANSIchar(FN) , nil, nil, sw_show );

end;

procedure TForm1.JvDragDrop1Drop(Sender: TObject; Pos: TPoint; Value: TStrings);

var S, FN, msg : string;
var i,max : integer;

begin

// --- INIT ---
max := value.Count;
msg := #13;

// ---

if max > 1 then
	begin

  FOR I:=0 to max do msg := msg +  #13 + value.strings[i];

  showMessageFMT('%d fichiers dposs',[max]);
  end;



  S :=  Value.strings[0];

  for i := 0 to length(S) do Dropped_FileName[i] := S[I+1];        // Translation chaine dans tableau l'octet 0 de s est shunt

  // --- Affiche le texte
 	FN := ExtractFileName (Dropped_Filename);
  form1.StatusBar1.Panels[0].text := FN;
  form1.TextTrayIcon1.ShowBalloonHint('Chargement en cours ...', FN, bitInfo, 10);


  // Cree le dossier
  form1.SAISIE_DOS.Execute;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

Action := CaNone; // annule
//Action := caMinimize;

INI_Save.execute;

form1.TextTrayIcon1.HideMainForm;
form1.TextTrayIcon1.Text := '...';

end;

procedure TForm1.FileExit1Hint(var HintStr: String; var CanShow: Boolean);
begin

application.Terminate;

end;

procedure TForm1.Mode_AUTORUNClick(Sender: TObject);
begin

Mode_AUTORUN.Checked := not Mode_AUTORUN.Checked;

if (Mode_AUTORUN.checked) then
  Write_RunKey( 'DRAGNDOC', paramstr(0) )
else
  Remove_RunKey( 'DRAGNDOC' );

SaveBOOL ('OPTIONS', 'AUTORUN', mode_autorun.checked, INI_FILE);

end;

procedure TForm1.INI_GETExecute(Sender: TObject);
begin

GetPosition( form1 );

App_PATH := ExtractFilePath(Application.ExeName);
INI_FILE := App_PATH + 'DRAGNDOC.INI';

DOS_ROOT := GetSTR ('DOSSIERS','ROOT', 'C:\ROOT', INI_FILE);
DOS_DATA := GetSTR ('DOSSIERS','DATA', DOS_ROOT + '\DATA',INI_FILE);
DOS_CONF := GetSTR ('DOSSIERS','CONF', DOS_ROOT + '\CONF',INI_FILE);
DOS_HELP     := GetSTR ('DOSSIERS','HELP', DOS_ROOT + '\AIDE',INI_FILE);

MODE := _Mode_DRAG; // par dfaut

mode_autorun.Checked := GetBOOL('OPTIONS', 'AUTORUN', False);

// === CREE LE DOSSIER LISTES SI N'EXISTE PAS ===
if not DirectoryExists( DOS_ROOT ) then
	if not CreateDir( DOS_ROOT )then
		raise
    	Exception.Create('Impossible de crer le dossier ROOT');

// === CREE LE DOSSIER LISTES SI N'EXISTE PAS ===
if not DirectoryExists( DOS_DATA) then
	if not CreateDir( DOS_DATA )then
		raise
    	Exception.Create('Impossible de crer le dossier DOS_DATA');

// === CREE LE DOSSIER CONFIG SI N'EXISTE PAS ===
if not DirectoryExists( DOS_CONF) then
	if not CreateDir( DOS_CONF )then
		raise
    	Exception.Create('Impossible de crer le dossier DOS_DATA');

// === CREE LE DOSSIER AIDES SI N'EXISTE PAS ===
if not DirectoryExists( DOS_HELP ) then
	if not CreateDir( DOS_HELP )then
		raise
    	Exception.Create('Impossible de crer le dossier AIDE');

end;

procedure TForm1.INI_SAVEExecute(Sender: TObject);
begin

SavePosition( form1 );
SaveBOOL ('OPTIONS', 'AUTORUN', mode_autorun.checked);

SaveSTR ('DOSSIERS','ROOT', DOS_ROOT, INI_FILE);
SaveSTR ('DOSSIERS','DATA', DOS_DATA, INI_FILE);
SaveSTR ('DOSSIERS','CONF', DOS_CONF, INI_FILE);
SaveSTR ('DOSSIERS','HELP', DOS_HELP, INI_FILE);



end;

procedure TForm1.CHK_exploreClick(Sender: TObject);
begin

chk_explore.checked := not chk_explore.checked; 

end;

procedure TForm1.OPTIONSExecute(Sender: TObject);
begin

frm_Options.show;

end;

end.



