unit jc_FILE;

interface

Uses
	SysUtils {Tsearch};

function GetFileSize(const APath: string): int64;

implementation

function GetFileSize(const APath: string): int64;

var
  Sr : TSearchRec;
begin
  if FindFirst(APath,faAnyFile,Sr)=0 then
  try
    Result := Int64(Sr.FindData.nFileSizeHigh) shl 32 + Sr.FindData.nFileSizeLow;
  finally
    FindClose(Sr);
  end
  else
    Result := 0;
end;
end.
