unit Unit1;
// Repertoire := ExtractFilePath(Application.ExeName);

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdActns, Menus, ImgList,
  StdCtrls, ShellApi, ComCtrls,
  jpeg, ExtCtrls,
  BandActn,
  clipbrd,

  CoolTrayIcon, TextTrayIcon,

  unit_Doc2RTF,

  variables_globales,

  jc_INI,
  jc_reg,
  jc_win,

  JvComponentBase,
  JvDragDrop,
  JvExControls, JvGradientHeaderPanel, JvFormMagnet, pngimage
;

type
  TForm1 = class(TForm)
    TextTrayIcon1: TTextTrayIcon;
    Popup_form: TPopupMenu;
    ActionList1: TActionList;
    ImageList1: TImageList;
    Maximiser: TAction;
    Minimiser: TAction;
    StatusBar1: TStatusBar;
    SAISIE_DOS: TAction;
    MEMO_CONF: TMemo;
    Sauve_POS_Saisie: TAction;
    Sauve_POS_Form1: TAction;
    SAUVE_POSITIONS: TAction;
    Locate_ROOT: TAction;
    Affiche_RTF: TAction;
    Explore_DATA: TAction;
    Memo: TAction;
    TypeOf_DOCS: TAction;
    Coller1: TMenuItem;
    Coller: TAction;
    Affiche_MEMO: TAction;
    run_PP: TAction;
    run_FIND: TAction;
    Changer_titre: TAction;
    Ouvrir_WRITE: TAction;
    Reinit: TAction;
    PROGRAM_VISUDOC: TAction;
    mnuFermer: TMenuItem;
    FileExit1: TFileExit;
    Quitter: TAction;
    Popup_Tray: TPopupMenu;
    mnuAGRANDIR: TMenuItem;
    N7: TMenuItem;
    INI_GET: TAction;
    INI_SAVE: TAction;
    Fermer1: TMenuItem;
    N6: TMenuItem;
    Close_WindowList: TAction;
    Fermertouteslesfentresouvertesdossierssurlebureau1: TMenuItem;
    Ouvrir_SCANSNAP: TAction;
    JvDragDrop1: TJvDragDrop;
    N2: TMenuItem;
    OuvrirleScanSnapORGANISER1: TMenuItem;
    mode_autorun: TMenuItem;
    N4: TMenuItem;
    chk_Explore: TMenuItem;
    N3: TMenuItem;
    Open_OPTIONS: TAction;
    JvGradientHeaderPanel1: TJvGradientHeaderPanel;
    Image1: TImage;
    Options1: TMenuItem;
    Restaurerlesparamtresdeconfiguration1: TMenuItem;
    Sauvegarderlesparamtresdeconfiguration1: TMenuItem;
    RInitialiser1: TMenuItem;
    N1: TMenuItem;
    Options2: TMenuItem;
    N5: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure MaximiserExecute(Sender: TObject);
    procedure MinimiserExecute(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure SAISIE_DOSExecute(Sender: TObject);
    procedure mnuVisu_DOCClick(Sender: TObject);
    procedure Explore_DATAExecute(Sender: TObject);
    procedure MemoExecute(Sender: TObject);
    procedure TypeOf_DOCSExecute(Sender: TObject);
    procedure CollerExecute(Sender: TObject);
    procedure Affiche_RTFExecute(Sender: TObject);
    procedure Affiche_MEMOExecute(Sender: TObject);
    procedure run_FCClick(Sender: TObject);
    procedure run_PPExecute(Sender: TObject);
    procedure run_FINDExecute(Sender: TObject);
    procedure Changer_titreExecute(Sender: TObject);
    procedure QuitterExecute(Sender: TObject);
    procedure JvGradientHeaderPanel1DblClick(Sender: TObject);
    procedure Ouvrir_WRITEExecute(Sender: TObject);
    procedure ReinitExecute(Sender: TObject);
    procedure PROGRAM_VISUDOCExecute(Sender: TObject);
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
      Value: TStrings);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FileExit1Hint(var HintStr: String; var CanShow: Boolean);
    procedure Mode_AUTORUNClick(Sender: TObject);
    procedure INI_GETExecute(Sender: TObject);
    procedure INI_SAVEExecute(Sender: TObject);
    procedure CHK_exploreClick(Sender: TObject);
    procedure Locate_ROOTExecute(Sender: TObject);
    procedure mnuAGRANDIRClick(Sender: TObject);
    procedure Rduire1Click(Sender: TObject);
    procedure mnuFermerClick(Sender: TObject);
    procedure Fermer1Click(Sender: TObject);
    procedure OuvrirleScanSnapManager1Click(Sender: TObject);
    procedure Close_WindowListExecute(Sender: TObject);
    procedure Ouvrir_SCANSNAPExecute(Sender: TObject);
    procedure Options1Click(Sender: TObject);

	  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  WindowList:Tlist;
  
CONST
	_MODE_DRAG = 0;
  _MODE_CLIP = 1;

implementation

uses visu_doc, form_OPTIONS, frm_InputDLG;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin

INI_GET.Execute;

// Active le Drag and drop entre Windows et Moi
form1.JvDragDrop1.AcceptDrag := true;

/// form1.JvGradientHeaderPanel1.LabelTop := 30;

end;

procedure TForm1.MaximiserExecute(Sender: TObject);
begin
form1.TextTrayIcon1.ShowMainForm;
form1.TextTrayIcon1.Text := '+';
end;

procedure TForm1.MinimiserExecute(Sender: TObject);
begin
form1.TextTrayIcon1.HideMainForm;
form1.TextTrayIcon1.Text := '...';
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
Application.Terminate;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TForm1.SAISIE_DOSExecute(Sender: TObject);
////////////////////////////////////////////////////////////////////////////////
begin

// Commence par vider le presse papier
clipbrd.Clipboard.Clear;

with frm_visudoc do begin
  jvCaptionDOC.caption := _DROPPED_FILENAME;
  _EXT :=  UpperCase(ExtractFileExt(_DROPPED_FILENAME));

  AcroPDF1.Align := AlClient;
  WebBrowser1.Align := AlClient;
  Image1.align := AlClient;

  JvAnimate1.align := AlClient;jvanimate1.active := False;JvAnimate1.transparent:= true;

if (_EXT = '.TXT')
	or (_EXT = '.INI')
  or (_EXT = '.HPM')
  or (_EXT = '.HPR')
  //or (_EXT = '.EML')
  then BEGIN
	form1.Affiche_RTF.Execute;
  RichEdit1.PlainText := True;
	RichEdit1.Lines.LoadFromFile( _DROPPED_FILENAME );
  END

else if _EXT = '.RTF' then BEGIN
	Affiche_RTF.execute;
  RichEdit1.PlainText := False;
	RichEdit1.Lines.LoadFromFile( _DROPPED_FILENAME );
  END

else if _EXT = '.DOC' then BEGIN
	Affiche_RTF.execute;
  RichEdit1.PlainText := False ;

  // Conversion DOC + RTF
	RichEdit1.text := Doc2RTF( _DROPPED_FILENAME );
 	RichEdit1.text := '';
  RichEdit1.Lines.LoadFromFile( _DROPPED_FILENAME );
  END

  else
  	if (_EXT = '.HTML')
  	or (_EXT = '.HTM')
    or (_EXT = '.EML')

    then BEGIN
	Panel_RTF.Visible := False;
  WebBrowser1.Visible := True;
  AcroPDF1.Visible := False;
	Image1.Visible := False;
  JvAnimate1.Visible := False;

  WebBrowser1.Navigate(_DROPPED_FILENAME,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
  END

else if _EXT = '.PDF' then begin
//	memo1.Visible := False;
  AcroPDF1.Visible := True;AcroPDF1.BringToFront;

	Panel_RTF.Visible := False;
  WebBrowser1.Visible := False;
	Image1.Visible := False;
  JvAnimate1.Visible := False;

  frm_visudoc.AcroPDF1.SRC := _DROPPED_FILENAME;
  end

else if (_EXT = '.JPG') or (_EXT = '.JPEG') or (_EXT = '.BMP') then begin
//	memo1.Visible := False;
	Panel_RTF.Visible := false;
  WebBrowser1.Visible := false;
  AcroPDF1.Visible := false;
	Image1.Visible := True;
  JvAnimate1.Visible := False;

  frm_visudoc.image1.Picture.LoadFromFile  (_DROPPED_FILENAME);
  end

else if _EXT = '.AVI' then begin
//	memo1.Visible := False;
	Panel_RTF.Visible := false;
  WebBrowser1.Visible := false;
  AcroPDF1.Visible := false;
	Image1.Visible := False;
  JvAnimate1.Visible := True;

  // Image1.BringToFront;
  frm_visudoc.JvAnimate1.FileName := _DROPPED_FILENAME;
  jvanimate1.active := True;
  end


else begin
	showmessage('Format ' + _EXT + ' Inconnu' + #13+#13+
  '=> Dposez du TXT,EML,INI,RTF,PDF,JPG,JPEG,BMP,AVI');
	Exit;

  end
End;

frm_visudoc.show;

end;



procedure TForm1.mnuVisu_DOCClick(Sender: TObject);
begin

Frm_VISUDOC.Show;

end;

procedure TForm1.Explore_DATAExecute(Sender: TObject);
begin

shellExecute (0,'EXPLORE', PansiChar(DOS_DATA), nil,nil, sw_show);
  
end;

procedure TForm1.MemoExecute(Sender: TObject);
begin

ShellExecute(0,'OPEN','NOTEPAD.EXE', '_MEMO.TXT',  pchar(app_path), sw_show);

end;

procedure TForm1.TypeOf_DOCSExecute(Sender: TObject);
begin

application.MessageBox(
'TEXTES:'+#13+
'-TXT,RTF,PDF'+#13+
#13+
'IMAGES:' + #13 +
'-BMP,JPG,JPEG'+#13+
#13+
'VIDEOS:'+#13+
'-AVI',
'TYPES DE DOBUMENTS ACCEPTES', mb_IconInformation );

    
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.CollerExecute(Sender: TObject);
////////////////////////////////////////////////////////////////////////////////
begin

// COLLE LE RESULTAT DU PRESSE PAPIER
MODE := _MODE_CLIP; // Mode clipBoard

_FICHIER_PATIENT := FormatDateTime ('yyyy-mm-dd_hh-nn-ss',now) + '.RTF';

frm_visudoc.Caption := _FICHIER_PATIENT;
frm_visudoc.RichEdit1.Text := ''; // Vide le RTF

frm_visudoc.RichEdit1.PasteFromClipboard; // Colle le PP

if trim(frm_visudoc.RichEdit1.text ) <> '' then begin
	frm_visudoc.Show;
	Affiche_RTF.Execute;

  _FN := ChangeFileExt(_FICHIER_PATIENT,''); // Ote l'extension
	_EXT := ExtractFileExt(_FICHIER_PATIENT);
  // Place les valeurs extraites dans VISUDOC
	WITH frm_VISUDOC.StatusBar1 DO  BEGIN
    Panels[0].text := DOS_DATA;
    Panels[1].text := _FN;
    Panels[2].text := _EXT;
END;
  end
else
	  form1.TextTrayIcon1.ShowBalloonHint(
    'Le Presse Papier est vide !',
    'Utilisez CTRL+C pour placer du texte dans le presse papier'+#13+
    'Ou dposez un document sur Drag&Doc' ,
   	bitInfo, 10);

    end;

procedure TForm1.Affiche_RTFExecute(Sender: TObject);
begin

with frm_VisuDoc do begin

	memo1.Visible := False;
  WebBrowser1.Visible := false;
  AcroPDF1.Visible := false;
	Image1.Visible := false;
  JvAnimate1.Visible := False;

	Panel_RTF.Visible := True;
  Panel_RTF.BringToFront;
  Panel_RTF.Align := AlClient
  
end;

end;

procedure TForm1.Affiche_MEMOExecute(Sender: TObject);
begin

with frm_visudoc do begin

	memo1.Visible := True;
	Panel_RTF.Visible := false;
  WebBrowser1.Visible := false;
  AcroPDF1.Visible := false;
	Image1.Visible := false;
  JvAnimate1.Visible := False;
end;

end;

procedure TForm1.run_FCClick(Sender: TObject);
begin

ShellExecute (0,'OPEN', 
	'C:\Program Files\FreeCommander\FreeCommander.exe',
  PAnsiChar(DOS_DATA), nil,sw_show);


end;

procedure TForm1.run_PPExecute(Sender: TObject);
begin

shellExecute(0,'OPEN','CLIPBRD.EXE', nil,nil,sw_show);

end;

procedure TForm1.run_FINDExecute(Sender: TObject);
begin

ShellExecute(0,'FIND',PAnsiChar(DOS_DATA), nil,nil,sw_show);


end;

procedure TForm1.Changer_titreExecute(Sender: TObject);
var titre : string;

begin

if inputQuery('Entrez un titre','TITRE', titre) then
	form1.caption := Titre;

end;

procedure TForm1.QuitterExecute(Sender: TObject);
begin

// ini_Save.execute;
Application.terminate;

end;

procedure TForm1.JvGradientHeaderPanel1DblClick(Sender: TObject);
begin

showmessage('OK');

end;

procedure TForm1.Ouvrir_WRITEExecute(Sender: TObject);
begin

ShellExecute(0,'OPEN','WRITE.EXE',nil,nil,sw_show);

end;

procedure TForm1.ReinitExecute(Sender: TObject);
begin

deletefile(INI_FILE);
application.Terminate;

end;

procedure TForm1.PROGRAM_VISUDOCExecute(Sender: TObject);
begin

_FN := App_Path + '\visu_doc.exe';
ShellExecute( handle, 'OPEN', PANSIchar(_FN) , nil, nil, sw_show );

end;

////////////////////////////////////////////////////////////////////////////////
procedure TForm1.JvDragDrop1Drop(Sender: TObject; Pos: TPoint; Value: TStrings);
////////////////////////////////////////////////////////////////////////////////
var S, msg : string;
var i : integer;
Begin

MODE := _MODE_DRAG; // Mode Drag and Doc

// --- INIT ---
_MAX_DROPPED := Value.Count;  // compte le nombre de fichiers dropps
msg := #13; // Saut de ligne

// --- CONFIRME LE DEPOT MULTIPLE ---
if _MAX_DROPPED > 1 then
	begin
    FOR I:=0 to _MAX_DROPPED -1 do msg := msg +  #13 + value.strings[i];
      showMessageFMT('%d fichiers dposs',[_MAX_DROPPED]);
  end;

  S :=  Value.strings[0];
  for i := 0 to length(S) do _DROPPED_FILENAME[i] := S[I+1];        // Translation chaine dans tableau l'octet 0 de s est shunt

  // --- Extrait le Nom du fichier dpos
  _FN := UpperCase( ExtractFileName (_DROPPED_FILENAME));

  form1.StatusBar1.Panels[0].text := _FN;
  form1.TextTrayIcon1.ShowBalloonHint('Chargement en cours ...', _FN, bitInfo, 10);

  // _EXT : Extrait l'Extension de ce fichier exemple => .PDF
  _EXT := ExtractFileExt(_FN);

  // _FN comporte le nom du fichier sans son extension
  _FN := ChangeFileExt(_FN,''); // Ote l'extension

// Place les valeurs extraites dans VISUDOC
WITH frm_VISUDOC.StatusBar1 DO  BEGIN
    Panels[0].text := DOS_DATA;
    Panels[1].text := _FN;
    Panels[2].text := _EXT;
END;

// --- LANCE VISU DOC => CREATION DE DOSSIER ///////////////////////////////////

// Close_WindowsList(Handle);        // Ferme les fentres ouvertes
form1.SAISIE_DOS.Execute;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

Action := CaNone; // annule
//Action := caMinimize;

INI_Save.execute;

form1.TextTrayIcon1.HideMainForm;
form1.TextTrayIcon1.Text := '...';

end;

procedure TForm1.FileExit1Hint(var HintStr: String; var CanShow: Boolean);
begin

application.Terminate;

end;

procedure TForm1.Mode_AUTORUNClick(Sender: TObject);
begin

Mode_AUTORUN.Checked := not Mode_AUTORUN.Checked;

if (Mode_AUTORUN.checked) then
  Write_RunKey( 'DRAGNDOC', paramstr(0) )
else
  Remove_RunKey( 'DRAGNDOC' );

end;

procedure TForm1.INI_GETExecute(Sender: TObject);
begin

// VAR GLOBALES
_App_PATH := ExtractFilePath(Application.ExeName);
INI_FILE := GetUserIniFileName;
MODE := _Mode_DRAG; // par dfaut

// DEFINITIONS DES CHEMINS
DOS_ROOT := GetSTR ('DOSSIERS','ROOT', 'C:\ROOT', INI_FILE);
DOS_DATA := GetSTR ('DOSSIERS','DATA', DOS_ROOT + '\DATA',INI_FILE);
DOS_CONF := GetSTR ('DOSSIERS','CONF', DOS_ROOT + '\CONF\DRAGNDOC',INI_FILE);
DOS_HELP := GetSTR ('DOSSIERS','HELP', DOS_ROOT + '\AIDE',INI_FILE);

// POSITION DU CARRE
GetPosition( form1 , INI_FILE );

// teste si l'autorun est activ dans la base de reg
mode_autorun.Checked := RunKey_Exists ('DRAGNDOC');

// === CREE LE DOSSIER LISTES SI N'EXISTE PAS ===
if not DirectoryExists( DOS_ROOT ) then
	if not CreateDir( DOS_ROOT )then raise	Exception.Create('Impossible de crer le dossier ROOT');

// === CREE LE DOSSIER LISTES SI N'EXISTE PAS ===
if not DirectoryExists( DOS_DATA) then
 	if not CreateDir( DOS_DATA )then raise Exception.Create('Impossible de crer le dossier DOS_DATA');

// === CREE LE DOSSIER CONFIG SI N'EXISTE PAS ===
if not DirectoryExists( DOS_CONF) then
	if not CreateDir( DOS_CONF )then raise Exception.Create('Impossible de crer le dossier DOS_DATA');

// === CREE LE DOSSIER AIDES SI N'EXISTE PAS ===
if not DirectoryExists( DOS_HELP ) then
	if not CreateDir( DOS_HELP )then
		raise Exception.Create('Impossible de crer le dossier AIDE');

end;

procedure TForm1.INI_SAVEExecute(Sender: TObject);
begin

SavePosition( form1, INI_FILE );
SaveBOOL ('OPTIONS', 'AUTORUN', mode_autorun.checked, INI_FILE);
SaveSTR ('DOSSIERS','ROOT', DOS_ROOT, INI_FILE);
SaveSTR ('DOSSIERS','DATA', DOS_DATA, INI_FILE);
SaveSTR ('DOSSIERS','CONF', DOS_CONF, INI_FILE);
SaveSTR ('DOSSIERS','HELP', DOS_HELP, INI_FILE);

end;

procedure TForm1.CHK_exploreClick(Sender: TObject);
begin

chk_explore.checked := not chk_explore.checked;

end;

procedure TForm1.Locate_ROOTExecute(Sender: TObject);
begin

frm_Options.show;

end;

procedure TForm1.mnuAGRANDIRClick(Sender: TObject);
begin

form1.TextTrayIcon1.ShowMainForm;

end;

procedure TForm1.Rduire1Click(Sender: TObject);
begin

form1.TextTrayIcon1.HideMainForm;

end;

procedure TForm1.mnuFermerClick(Sender: TObject);
begin

form1.close;

// form1.TextTrayIcon1.HideMainForm;


end;

procedure TForm1.Fermer1Click(Sender: TObject);
begin

application.Terminate;

end;

procedure TForm1.OuvrirleScanSnapManager1Click(Sender: TObject);
begin

ShellExecute(0,'OPEN', 'C:\Program Files\PFU\ScanSnap\Organizer\PfuSsOrg.exe', nil,nil,sw_show);

end;


procedure TForm1.Close_WindowListExecute(Sender: TObject);
begin
Close_WindowsList (Handle);
end;

procedure TForm1.Ouvrir_SCANSNAPExecute(Sender: TObject);
begin

ShellExecute(0,'OPEN',PChar(GetProgramFilesDir + '\pfu\scansnap\organizer\pfussorg.exe'),nil,nil,sw_show);


end;

procedure TForm1.Options1Click(Sender: TObject);
begin

frm_options.Show;

end;

end.



