unit form_OPTIONS;

interface

uses Windows,
SysUtils,
Classes,
Graphics,
Forms,
Controls,
StdCtrls,
  Buttons, ComCtrls, ExtCtrls, Mask,dialogs, Grids,
  ValEdit,
  ShellApi,

  variables_globales,

  JvExMask,
  JvToolEdit

  ;

type
  Tfrm_OPTIONS = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    JvDirectoryEdit1: TJvDirectoryEdit;
    ValueListEditor1: TValueListEditor;
    Edit_PATH: TEdit;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure JvDirectoryEdit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ValueListEditor1DblClick(Sender: TObject);
    procedure ValueListEditor1SelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { dclarations prives }
  public
    { dclarations publiques }
  end;

var
  frm_OPTIONS: Tfrm_OPTIONS;

implementation

uses unit1, frm_InputDLG;

{$R *.dfm}

procedure Tfrm_OPTIONS.FormCreate(Sender: TObject);
begin

frm_options.JvDirectoryEdit1.Text := dos_root;

end;

procedure Tfrm_OPTIONS.JvDirectoryEdit1Change(Sender: TObject);
begin

dos_root := JvDirectoryEdit1.Text;
dos_data := dos_root + '\data';
dos_conf := dos_root + '\conf';
dos_help := dos_root + '\help';

frm_options.ValueListEditor1.Strings[0] := 'Application='+ _App_PATH;
frm_options.ValueListEditor1.Strings[1] := 'Fichier INI='+ INI_FILE;
frm_options.ValueListEditor1.Strings[2] := 'Dossier des Donnes='+ dos_data;
frm_options.ValueListEditor1.Strings[3] := 'Dossier de Configuration=' + dos_conf;
frm_options.ValueListEditor1.Strings[4] := 'Dossier Aide=' + dos_help;

end;

procedure Tfrm_OPTIONS.BitBtn1Click(Sender: TObject);
begin

form1.INI_SAVE.Execute;

// Charhe les liste dans el nouveau dossier CONF
form_InputDLG.Listes_Get.execute;

close;
end;

procedure Tfrm_OPTIONS.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
form1.INI_GET.Execute();
end;

procedure Tfrm_OPTIONS.ValueListEditor1DblClick(Sender: TObject);
begin

showMessage(ValueListEditor1.Values['Donnes']);

end;


procedure Tfrm_OPTIONS.ValueListEditor1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin

Edit_PATH.Text := ValueListEditor1.Values[ValueListEditor1.Keys[Arow]];


end;


procedure Tfrm_OPTIONS.BitBtn2Click(Sender: TObject);
begin
ShellExecute(0,'OPEN',PCHAR(Edit_PATH.Text), NIL,NIL,SW_SHOW);      
end;

procedure Tfrm_OPTIONS.BitBtn3Click(Sender: TObject);
begin

form1.INI_SAVE.Execute;
form_InputDLG.Listes_Get.execute;

end;

end.

