unit frm_InputDLG;

{
  Inputdlg se comporte comme une boite de dialogue modale
  Qui retourne
  - _OK = True si l'on veut depllacer le fichier
  - Et _Ok = False si on clique sur Annuler

  Appel par VISUDOC , le renommage dplacement se fait dans Visudoc
  Procdure MoveInList . Execute
}


interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs, ActnList,
  ShellApi,StrUtils,Menus,ComCtrls,

  variables_globales,

  jc_INI,
  jc_LISTES_TRAY,
  jc_win,



  JvExControls, JvGradientHeaderPanel, JvGradient, JvXPCore, JvXPButtons,
  JvExExtCtrls, JvExtComponent, JvCaptionPanel
  ;

type
  Tform_InputDLG = class(TForm)
    ActionList1: TActionList;
    LISTES_GET: TAction;
    LISTES_SAVE: TAction;
    Popup_Docteurs: TPopupMenu;
    EDIT_CORRES: TMenuItem;
    Popup_1: TPopupMenu;
    MenuItem1: TMenuItem;
    Popup_2: TPopupMenu;
    MenuItem2: TMenuItem;
    DEPOUSSIERE_FichierPatient: TAction;
    DEPOUSSIEREFichierPatient1: TMenuItem;
    Ranger: TAction;
    Rangerledocument1: TMenuItem;
    Rangerledocument2: TMenuItem;
    Popup_3: TPopupMenu;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    titre_1: TMenuItem;
    N3: TMenuItem;
    itre1: TMenuItem;
    N4: TMenuItem;
    itre2: TMenuItem;
    TITRE: TJvGradientHeaderPanel;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Outils1: TMenuItem;
    mnu_LISTES_UPDATE: TMenuItem;
    LISTESSAVE1: TMenuItem;
    Rangerledocument3: TMenuItem;
    JvGradient1: TJvGradient;
    Panel1: TPanel;
    Panel2: TPanel;
    N5: TMenuItem;
    Explorerledossierdeslistes1: TMenuItem;
    btn_OK: TJvXPButton;
    btn_RAZ: TJvXPButton;
    GroupBox_CORRES: TJvCaptionPanel;
    Liste_DOCTEURS: TComboBox;
    GroupBox_2: TJvCaptionPanel;
    GroupBox_1: TJvCaptionPanel;
    Liste_1: TComboBox;
    Liste_2: TComboBox;
    GroupBox_4: TJvCaptionPanel;
    GroupBox_3: TJvCaptionPanel;
    Liste_3: TComboBox;
    JvCaptionPanel1: TJvCaptionPanel;
    Image1: TImage;
    FileName: TEdit;
    Prefixe: TComboBox;
    DateTimePicker1: TDateTimePicker;
    Extension: TEdit;
    RestaurerlesListesdechoix1: TMenuItem;
    N6: TMenuItem;
    RestaurerlesListesdechoix2: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    RestaurerlesListesdechoix3: TMenuItem;
    RestaurerlesListesdechoix4: TMenuItem;
    N9: TMenuItem;
    itre3: TMenuItem;
    Liste_4: TListBox;
    Supprilmercetteentre1: TMenuItem;
    Supprimer1: TMenuItem;
    Supprimer2: TMenuItem;
    Supprimer3: TMenuItem;
    procedure btn_OKClick(Sender: TObject);
    procedure Liste_DOCTEURSClick(Sender: TObject);
    procedure btn_RAZClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Liste_DOCTEURSExit(Sender: TObject);
    procedure Liste_1Exit(Sender: TObject);
    procedure LISTES_GETExecute(Sender: TObject);
    procedure LISTES_SAVEExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Liste_1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Liste_2Exit(Sender: TObject);
    procedure Liste_2Click(Sender: TObject);
    procedure EDIT_CORRESClick(Sender: TObject);
    procedure Liste_EXAMENSDblClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure DEPOUSSIERE_FichierPatientExecute(Sender: TObject);
    procedure RangerExecute(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure Liste_3Click(Sender: TObject);
    procedure Liste_3Exit(Sender: TObject);
    procedure titre_1Click(Sender: TObject);
    procedure itre1Click(Sender: TObject);
    procedure itre2Click(Sender: TObject);
    procedure DateTimePicker1Click(Sender: TObject);
    procedure Explorerledossierdeslistes1Click(Sender: TObject);
    procedure Liste_4Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure itre3Click(Sender: TObject);
    procedure PrefixeExit(Sender: TObject);
    procedure JvCaptionPanel1Click(Sender: TObject);
    procedure Supprilmercetteentre1Click(Sender: TObject);
    procedure Supprimer1Click(Sender: TObject);
    procedure Supprimer2Click(Sender: TObject);
    procedure Supprimer3Click(Sender: TObject);
  private
    { dclarations prives }
  public
    { dclarations publiques }
  end;

var
  form_InputDLG: Tform_InputDLG;

implementation

{$R *.dfm}

uses unit1; {ROOT}

procedure Tform_InputDLG.btn_OKClick(Sender: TObject);
var tiret : string;
begin

_REPONSE_OK := False;

// RETOURNE _PREFIXE ARGUMENTE
_PREFIXE := UpperCase(Prefixe.text); // Mise en maj
if _PREFIXE = '' then tiret := '' else tiret := '_';
_FICHIER_PATIENT := _PREFIXE + tiret + FileName.Text + Extension.Text;

if InputQuery(
  'Ranger la Fiche dans son Dossier ?', _DOSSIER_PATIENT, _FICHIER_PATIENT ) = true then
  begin
    _REPONSE_OK := True;
    // --- Liste des prefixes de la session
    AddToCombo(Prefixe, _PREFIXE );
    Close;

  End;


end;

procedure Tform_InputDLG.Liste_DOCTEURSClick(Sender: TObject);
begin

// --- Liste des prefixes de la session
AddToCombo(prefixe, _PREFIXE );
Prefixe.Text := Liste_DOCTEURS.Text;

end;

procedure Tform_InputDLG.btn_RAZClick(Sender: TObject);
begin

if Prefixe.Text <> '' then BEGIN
	Prefixe.Text := '';
  Prefixe.SetFocus;
  END
else BEGIN
	_PREFIXE := '';
	_REPONSE_OK := FALSE;
	Close;
  END;



end;

procedure Tform_InputDLG.FormShow(Sender: TObject);
begin

self.Prefixe.SetFocus;

end;

procedure Tform_InputDLG.Liste_DOCTEURSExit(Sender: TObject);
begin

form_InputDlg.Liste_DOCTEURS.Text := UpperCase ( form_InputDlg.Liste_DOCTEURS.Text );
self.Prefixe.Text := Liste_DOCTEURS.Text;

//-- Favoris ajoute si existe pas dj
AddToCombo(form_InputDlg.Liste_DOCTEURS);


end;

procedure Tform_InputDLG.Liste_1Exit(Sender: TObject);
begin
form_InputDlg.Liste_1.Text := UpperCase ( form_InputDlg.Liste_1.Text );
self.Prefixe.Text := Liste_1.Text;
AddToCombo(form_InputDlg.Liste_1);
end;


procedure Tform_InputDLG.LISTES_GETExecute(Sender: TObject);
begin

// Rajoute une nom de corres si absent
if _prefixe = '' then _prefixe := GetStr('DOCUMENTS', 'TYPE_DERNIER', '', INDEX_INI);
prefixe.text :=  _prefixe;

if fileexists (DOS_CONF + '\DOCTEURS.TXT') then  	Liste_DOCTEURS.Items.LoadFromFile(DOS_CONF + '\DOCTEURS.TXT');
if fileexists (DOS_CONF + '\LISTE_1.TXT')  then  	Liste_1.Items.LoadFromFile(DOS_CONF + '\LISTE_1.TXT');
if fileexists (DOS_CONF + '\LISTE_2.TXT')  then  	LISTE_2.Items.LoadFromFile(DOS_CONF + '\LISTE_2.TXT');
if fileexists (DOS_CONF + '\LISTE_3.TXT')  then  	LISTE_3.Items.LoadFromFile(DOS_CONF + '\LISTE_3.TXT');
{ La liste 4 ne dure que le temps de la session }
//if fileexists (DOS_CONF + '\LISTE_4.TXT')  then  	LISTE_4.Items.LoadFromFile(DOS_CONF + '\LISTE_4.TXT');


if FileExists(DOS_CONF + '\Liste_Prefixes.txt') then form_InputDlg.Prefixe.Items.LoadFromFile(DOS_CONF + '\Liste_Prefixes.txt');

// Liste_Patient.Items[0] := GetStr('DOCUMENTS','TYPE_DERNIER','', INDEX_INI) ;

GroupBox_CORRES.caption := GetSTR ('TITRES','0', 'Mdecins');
GroupBox_1.caption := GetSTR ('TITRES','1', 'Gynco');
GroupBox_2.caption := GetSTR ('TITRES','2', 'Obsttrique');
GroupBox_3.caption := GetSTR ('TITRES','3', 'Divers');
GroupBox_4.caption := GetSTR ('TITRES','4', 'Derniers');

end;

procedure Tform_InputDLG.LISTES_SAVEExecute(Sender: TObject);
begin
Try
// Liste des Prfixes

form_InputDlg.Liste_DOCTEURS.Items.SaveToFile( DOS_CONF + '\DOCTEURS.TXT');
form_InputDlg.LISTE_1.Items.SaveToFile( DOS_CONF + '\LISTE_1.TXT');
form_InputDlg.LISTE_2.Items.SaveToFile( DOS_CONF + '\LISTE_2.TXT');
form_InputDlg.LISTE_3.Items.SaveToFile( DOS_CONF + '\LISTE_3.TXT');
//  form_InputDlg.LISTE_4.Items.SaveToFile( DOS_CONF + '\LISTE_4.TXT');

form_InputDlg.Prefixe.Items.SaveToFile(DOS_CONF + '\Liste_Prefixes.txt');

Except
  ShowMessage('ERREUR: LISTES_SAVEExecute');
  end;

end;

procedure Tform_InputDLG.FormClose(Sender: TObject; var Action: TCloseAction);
begin

self.LISTES_SAVE.Execute;

end;

procedure Tform_InputDLG.FormCreate(Sender: TObject);
begin

self.LISTES_GET.Execute;

end;

procedure Tform_InputDLG.Liste_1Click(Sender: TObject);
begin

self.Prefixe.Text := self.Liste_1.Text;

end;

procedure Tform_InputDLG.FormKeyPress(Sender: TObject; var Key: Char);
begin

case Key of
   #13 : btn_ok.Click;
   #27 : btn_RAZ.click;
end;


end;



procedure Tform_InputDLG.Liste_2Exit(Sender: TObject);
begin
form_InputDlg.LISTE_2.Text := UpperCase ( form_InputDlg.LISTE_2.Text );
self.Prefixe.Text := LISTE_2.Text;
AddToCombo(form_InputDlg.LISTE_2);
end;

procedure Tform_InputDLG.Liste_2Click(Sender: TObject);
begin
self.Prefixe.Text := self.LISTE_2.Text;
end;

procedure Tform_InputDLG.EDIT_CORRESClick(Sender: TObject);
begin

ShellExecute(0,'OPEN', PansiChar(DOS_CONF + '\DOCTEURS.TXT'), nil,nil, sw_show);

end;

procedure Tform_InputDLG.Liste_EXAMENSDblClick(Sender: TObject);
begin

btn_ok.click;


end;

procedure Tform_InputDLG.MenuItem1Click(Sender: TObject);
begin

ShellExecute(0,'OPEN', PansiChar(DOS_CONF + '\Liste_1.TXT'), nil,nil, sw_show);

end;

procedure Tform_InputDLG.MenuItem2Click(Sender: TObject);
begin

ShellExecute(0,'OPEN', PansiChar(DOS_CONF + '\LISTE_2.TXT'), nil,nil, sw_show);


end;

procedure Tform_InputDLG.DEPOUSSIERE_FichierPatientExecute(Sender: TObject);
begin

if _FICHIER_PATIENT[1] = '_' then _FICHIER_PATIENT := COPY(_FICHIER_PATIENT, 2,255);
_FICHIER_PATIENT := AnsiReplaceStr(_FICHIER_PATIENT, 'TEMP','');
_FICHIER_PATIENT := AnsiReplaceStr(_FICHIER_PATIENT, 'TEMP',''); 	// elimine les temp
_FICHIER_PATIENT := AnsiReplaceStr(_FICHIER_PATIENT, 'Binder',''); 	// elimine les temp

_FICHIER_PATIENT := AnsiReplaceStr(_FICHIER_PATIENT, '__','_');   // elimemine les doubles __
_FICHIER_PATIENT := AnsiReplaceStr(_FICHIER_PATIENT, '__','_');

end;

procedure Tform_InputDLG.RangerExecute(Sender: TObject);
var
	tiret : string;
begin

/// Annnule la double demande
if _REPONSE_OK = True then Exit;

// Place le Flag Reponse sur OK lu dans Main Form
// _REPONSE_OK := False;


// RETOURNE _PREFIXE ARGUMENTE
_PREFIXE := UpperCase(Prefixe.text); // Mise en maj
if _PREFIXE = '' then tiret := '' else tiret := '_';
// _FICHIER_PATIENT := _PREFIXE + tiret + FileName.Text + Extension.Text;
/// FileName.Text := copy (AnsiReplaceStr(FileName.Text,'_','-'),1,10);
FileName.Text := AnsiReplaceStr(FileName.Text,'_','-');

_FICHIER_PATIENT := FileName.Text + tiret + _PREFIXE + Extension.Text;

if InputQuery('Ranger la Fiche dans son Dossier ?',
  _DOSSIER_PATIENT, _FICHIER_PATIENT ) = true then
  begin
    _REPONSE_OK := True;

    // --- Liste des prefixes de la session
    AddToCombo(prefixe, _PREFIXE );
    //--------------------------------------------------------------------------
		Close_WindowsList(Handle);        // Ferme les fentres ouvertes
		//--------------------------------------------------------------------------

  Close;

  End;

//  self.LISTES_SAVE.Execute;

end;

procedure Tform_InputDLG.MenuItem3Click(Sender: TObject);
begin

ShellExecute(0,'OPEN', PansiChar(DOS_CONF + '\Liste_3.TXT'), nil,nil, sw_show);

end;

procedure Tform_InputDLG.Liste_3Click(Sender: TObject);
begin
self.Prefixe.Text := self.LISTE_3.Text;
end;

procedure Tform_InputDLG.Liste_3Exit(Sender: TObject);
begin
form_InputDlg.LISTE_3.Text := UpperCase ( form_InputDlg.LISTE_3.Text );
self.Prefixe.Text := LISTE_3.Text;
AddToCombo(form_InputDlg.LISTE_3);
end;

procedure Tform_InputDLG.titre_1Click(Sender: TObject);
var REP : string;
begin

REP :=  GroupBox_1.caption;

if InputQuery('TITRE LISTE 1','Entrez un nouveau titre pour cette liste',rep) then
  begin
   GroupBox_1.caption := REP;
   SaveStr('TITRES','1', REP);
  end;

end;

procedure Tform_InputDLG.itre1Click(Sender: TObject);
var REP : string;
begin

REP :=  GroupBox_2.caption;

if InputQuery('TITRE LISTE 2','Entrez un nouveau titre pour cette liste',rep) then
  begin
   GroupBox_2.caption := REP;
   SaveStr('TITRES','2', REP);
  end;

end;

procedure Tform_InputDLG.itre2Click(Sender: TObject);
var REP : string;
begin

REP :=  GroupBox_3.caption;

if InputQuery('TITRE LISTE 3','Entrez un nouveau titre pour cette liste',rep) then
  begin
   GroupBox_3.caption := REP;
   SaveStr('TITRES','3', REP);
  end;

end;

procedure Tform_InputDLG.DateTimePicker1Click(Sender: TObject);
begin

FileName.Text := FormatDateTime('yyyy_mm_dd_hh_nn_ss',self.DateTimePicker1.Date);

end;

procedure Tform_InputDLG.Explorerledossierdeslistes1Click(Sender: TObject);
begin
ShellExecute(Handle,'OPEN',PChar(DOS_CONF),Nil,Nil,SW_SHOW);
end;

procedure Tform_InputDLG.Liste_4Click(Sender: TObject);
begin
Prefixe.Text := LISTE_4.Items[ Liste_4.itemIndex ];
end;

procedure Tform_InputDLG.MenuItem7Click(Sender: TObject);
begin

ShellExecute(0,'OPEN', PansiChar(DOS_CONF + '\Liste_4.TXT'), nil,nil, sw_show);

end;

procedure Tform_InputDLG.MenuItem8Click(Sender: TObject);
var REP : string;
begin

REP :=  GroupBox_4.caption;

if InputQuery('TITRE LISTE 4','Entrez un nouveau titre pour cette liste',rep) then
  begin
   GroupBox_4.caption := REP;
   SaveStr('TITRES','4', REP);
  end;

end;

procedure Tform_InputDLG.itre3Click(Sender: TObject);
var rep : string;
begin

REP :=  GroupBox_corres.caption;

if InputQuery('TITRE LISTE CORRESPONDANTS','Entrez un nouveau titre pour cette liste',rep) then
  begin
   GroupBox_CORRES.caption := REP;
   SaveStr('TITRES','0', REP);
  end;

end;

procedure Tform_InputDLG.PrefixeExit(Sender: TObject);
begin

AddToCombo(Prefixe);
AddToList(Liste_4, Prefixe.Text);

end;

procedure Tform_InputDLG.JvCaptionPanel1Click(Sender: TObject);
begin

prefixe.Text := '';

end;

procedure Tform_InputDLG.Supprilmercetteentre1Click(Sender: TObject);
begin

Liste_DOCTEURS.DeleteSelected;

end;

procedure Tform_InputDLG.Supprimer1Click(Sender: TObject);
begin

Liste_1.DeleteSelected;

end;

procedure Tform_InputDLG.Supprimer2Click(Sender: TObject);
begin

Liste_2.DeleteSelected;

end;

procedure Tform_InputDLG.Supprimer3Click(Sender: TObject);
begin

Liste_3.DeleteSelected;

end;

end.

